
var client={
/*	BELIEVED UNUSED 20161223	
*/		
}



var Plate={

		constructs:null,
		plateType:null,
		
		/*
		 * Selected coordinate ranges for setting a construct. These defaults do all drops in the entire plate.
		 * These are 1-based, ie A1 drop 1 is selectionDrop, selectionTop and selectionLeft all 1.
		 */
		selectionDrop:-1,
		selectionTop:-1,
		selectionBottom:10000,
		selectionLeft:-1,
		selectionRight:10000,

		
		/*
	 	 * PROTEIN tab
	 	 */

	 	/**
	 	 * Begins the process of setting a protein.
	 	 * @param handler A function to clean up the page after setting
	 	 */
		beginSetProtein: function(handler){
			if("Default Project"==data.projectname){
				new Ajax.Request('/api/project/?pagesize=1000',{
					method:'get',
					onSuccess:function(transport){
						if(!AjaxUtils.checkResponse(transport)){ return false; }
						Plate.showProjectList(transport.responseJSON, handler);
					},
					onFailure:function(transport){
						AjaxUtils.checkResponse(transport);
					},
				});
			} else {
				Plate.showProjectList({'rows':[{ name:data.projectname, id:data.projectid, description:'Plate is in project "'+data.projectname+'". You can choose from proteins in that project' }]}, handler);
			}
		},
		
		showProjectList: function(projects, handler){
			var mb=ui.modalBox({
				'title':'Choose the construct',
				'content':''
			});
			Plate.doAfter=handler;
			projects.rows.each(function(p){
				if(1==p.isarchived || 1==p.issystem){ return; } //from this iteration
				var ti=mb.treeItem({
					record:p,
					id:"project"+p.id,
					header:p.name+": "+p.description+"",
					updater:Plate.showProteinsForTarget
				});
			});
			if(1==mb.select(".treeitem").length){
				//Plate.showProteinsForTarget(mb.down(".treeitem"));
				mb.select(".treehead")[0].click();
			}		
		},

		showProteinsForTarget: function(elem){
			if(elem.up(".treeitem")){ elem=elem.up(".treeitem"); }
			var proj=elem.record;
			new Ajax.Request('/api/project/'+proj.id+'/protein?pagesize=1000',{
				method:'get',
				onSuccess:function(transport){
					if(!AjaxUtils.checkResponse(transport)){ return false; }
					elem.down(".treebody").innerHTML='';
					transport.responseJSON.rows.each(function(p){
						var ti=elem.treeItem({
							record:p,
							id:"protein"+p.id,
							header:p.name+" ("+p.proteinacronym+"): "+p.description+"",
							updater:Plate.showConstructsForProtein
						});
					});
				},
				onFailure:function(transport){
					if(404==transport.status){
						elem.down(".treebody").innerHTML='<label style="text-align:left">No proteins in this project</label>';
						return;
					}
					AjaxUtils.checkResponse(transport);
				},
			});
		},

		showConstructsForProtein: function(elem){
			if(elem.up(".treeitem")){ elem=elem.up(".treeitem"); }
			var prot=elem.record;
			new Ajax.Request('/api/protein/'+prot.id+'/construct?pagesize=1000',{
				method:'get',
				onSuccess:function(transport){
					if(!AjaxUtils.checkResponse(transport)){ return false; }
					elem.down(".treebody").innerHTML='';
					transport.responseJSON.rows.each(function(c){
						var lbl=document.createElement("label");
						lbl.className="treeitem"
						lbl.record=c;
						lbl.innerHTML='<input type="button" value="Use this construct" onclick="Plate.setConstruct(this)" style="cursor:pointer" /> '+c.name+": "+c.description;
						lbl.style.textAlign="left";
						lbl.style.padding="0.5em 0.25em";
						elem.down(".treebody").appendChild(lbl);
					});
				},
				onFailure:function(transport){
					if(404==transport.status){
						elem.down(".treebody").innerHTML="No constructs for this protein";
						return;
					}
					AjaxUtils.checkResponse(transport);
				},
			});
		},

		setConstruct: function(btn){
			var construct=btn.up(".treeitem").record;
			/*
			on success, do modalBox.doAfter and close mb
			on failure close mb
			*/
			new Ajax.Request("/api/plate/"+data.id, {
				method:'patch',
				parameters:{
					csrfToken:csrfToken,
					constructid:construct.id,
					selectionDrop:Plate.selectionDrop,
					selectionTop:Plate.selectionTop,
					selectionBottom:Plate.selectionBottom,
					selectionLeft:Plate.selectionLeft,
					selectionRight:Plate.selectionRight,
				},
				onSuccess:function(transport){ 
					AjaxUtils.checkResponse(transport);
					Plate.doAfter(transport);
					ui.closeModalBox();
				},
				onFailure:function(transport){ 
					AjaxUtils.checkResponse(transport);
				},
			});
		},

		
		afterSetConstruct: function(transport){
			data=transport.responseJSON.updated;
			Plate.constructs=null;
			Plate.renderProteinTab();
			Plate.renderScreenTab();
			var projectLink=$("project_label").down("a");
			projectLink.href="/project/"+data.projectid;
			projectLink.innerHTML=data.projectname;
			ui.closeModalBox();
		},

		/**
		 * Renders the "Protein" tab.
		 * TODO If more than one construct per plate is allowed, UI.
		 */
		renderProteinTab:function(){
			$("proteins_body").innerHTML='';
			if(null==Plate.constructs){
				window.setTimeout(Plate.getConstructs,50);
				return;
			}
			var out='';
			var f=$("proteins_body").form({
				id:'proteinstabform',
				action:'/api/plate/'+data.id,
				method:'patch'
			});
			if(0==Plate.constructs.length){
				f.textField({
					label:'No protein is set',
					name:'noprotein',
					value:'',
					readonly:true
				});
				if(canEdit){
					f.buttonField({
						label:'Choose the protein...',
						onclick:function(){ Plate.beginSetProtein(Plate.afterSetConstruct);return false; },
						readonly:true
					});
				}
				out='<a href="#" onclick="Plate.beginSetProtein(Plate.afterSetConstruct);return false">Set protein construct...</a>';
			} else if(1==Plate.constructs.length){
				var c=Plate.constructs[0];
				f.textField({
					label:'Protein',
					name:'proteinname',
					value:c.proteinname,
					readonly:true
				});
				f.textField({
					label:'Protein acronym',
					name:'proteinacronym',
					value:c.proteinacronym,
					readonly:true
				});
				f.textField({
					label:'Construct',
					name:'constructname',
					value:c.name+': '+c.description,
					readonly:true
				});
				if(canEdit){
					f.buttonField({
						label:'Change the protein...',
						onclick:function(){ Plate.beginSetProtein(Plate.afterSetConstruct);return false; },
						readonly:true
					});
				}
				window.setTimeout(Plate.showProteinConcentration,50);
				
			} else {
				//TODO multi construct plate ui, and
				//plate.showProteinSolution();
			}
			
		},

		getWellDrops:function(){
			new Ajax.Request("/api/plate/"+data.id+"/welldrop",{
				method:'get',
				onSuccess:Plate.getWellDrops_onSuccess,
				onFailure:Plate.getWellDrops_onFailure,
			});
		},
		getWellDrops_onSuccess:function(transport){
			if(!AjaxUtils.checkResponse(transport)){ return false; }
			data.welldrops=transport.responseJSON.rows;
		},
		getWellDrops_onFailure:function(transport){ 
			return AjaxUtils.checkResponse(transport);
		},

		showProteinConcentration:function(){
			if(!data.welldrops){
				window.setTimeout(Plate.showProteinConcentration,100);
				return false;
			}
			/*
			 * Initial implementation assumes this is the same across all wells/drops
			 */
			var wd=data.welldrops[0];
			var proteinBuffer=wd.proteinbuffer
			var concAmount=wd.proteinconcentrationamount;
			var concUnit=wd.proteinconcentrationunit;
			var f=$("proteinstabform");
			f.textArea({
				label:'Protein buffer',
				name:'proteinbuffer',
				value:proteinBuffer,
				readonly:!canEdit
			});
			var concContent=concAmount+concUnit.replace("u","&#181;");
			if(canEdit){
				concContent='<input type="text" id="proteinconcentrationamount" name="proteinconcentrationamount" value="'+concAmount+'" style="width:3em"/>';
				concContent+='<select id="proteinconcentrationunit" name="proteinconcentrationunit">';
				concContent+='<option value="mg/mL" '+( 'mg/mL'==concUnit ?  'selected="selected"' : '' )+'>mg/mL</option>';
				concContent+='<option value="ug/uL" '+( 'ug/uL'==concUnit ?  'selected="selected"' : '' )+'>&#181;g/&#181;L</option>';
				concContent+='</select>';
			}
			f.formField({
				label:'Protein concentration',
				content:concContent
			});
			if(canEdit){
				fieldValidations["proteinconcentrationamount"]=["required","float"];
				$("proteinbuffer").observe("keyup",Plate.updateProteinConcentration);
				$("proteinconcentrationamount").observe("keyup",Plate.updateProteinConcentration);
				$("proteinconcentrationunit").observe("keyup",Plate.updateProteinConcentration);
				$("proteinconcentrationunit").observe("change",Plate.updateProteinConcentration);
			}
		},
		
		updateProteinConcentration:function(evt){
			var field=evt.target;
			window.clearTimeout(submitTimer);
			if(!validator.validate(field)){ return false; }
			if(field.up("label,td")){ field.up("label,td").removeClassName("invalidfield"); }
			window.submitTimer=setTimeout(function(){ Plate.doUpdateProteinConcentration(field) },1500);
		},
		doUpdateProteinConcentration:function(field){
			field.up("label").addClassName("updating");
			new Ajax.Request('/api/plate/'+data.id, {
				method:'patch',
				postBody:"csrfToken="+csrfToken+"&"+field.name+"="+field.value, //Defaults on server to all drops in all wells
				onSuccess:Plate.updateProteinConcentration_onSuccess,
				onFailure:Plate.updateProteinConcentration_onFailure
			});
		},
		updateProteinConcentration_onSuccess:function(transport){
			if(!AjaxUtils.checkResponse(transport)){ return false; }
			$("proteinbuffer").up("label").removeClassName("updating");
			$("proteinconcentrationamount").up("label").removeClassName("updating");
			data.wellDrops=transport.responseJSON.rows;
		},
		updateProteinConcentration_onFailure:function(transport){
			return AjaxUtils.checkResponse(transport);
		},
		
		getConstructs: function(){
			new Ajax.Request("/api/plate/"+data.id+'/construct', {
				method:'get',
				onSuccess:function(transport){ 
					AjaxUtils.checkResponse(transport);
					Plate.constructs=transport.responseJSON.rows;
					Plate.renderProteinTab();
					return;
				},
				onFailure:function(transport){ 
					if(404==transport.status){
						Plate.constructs=new Array();
						Plate.renderProteinTab();
						return;
					}
					Ajax.checkResponse(transport); 
				},
			});
		},
		
	  	/*
	  	 * SCREEN tab
	  	 */
		renderScreenTab: function(){
			var tab=$("screens_body");
			tab.dataset.apiurl='/api/screen/'+data.screenid+'/screencondition';
			if('Default Project'==data.projectname){
				if(canEdit){
					tab.innerHTML='Set the protein first';
				} else {
					tab.innerHTML='No screen has been chosen for this plate.';
				}
				return false;
			}
			if(""==data.screenid){
				tab.innerHTML='(No screen has been chosen)'+
				'<br/><br/><hr/>';
				if(canEdit){
					tab.innerHTML+='Choose a standard screen: <input type="button" value="Choose..." onclick="Plate.beginSetScreen(Plate.afterSetScreen)"'+
					'<br/><br/><hr/>'+
					'<form action="/api/screen" method="post" id="uploadscreen"><div>'+
					'<input type="hidden" name="name" value="Optimization '+data.name+'" />'+
					'<input type="hidden" name="projectid" value="'+data.projectid+'" />'+
					'<input type="hidden" name="rows" value="" />'+
					'<input type="hidden" name="cols" value="" />'+
					'<input type="hidden" name="csrfToken" value="'+csrfToken+'" />'+
					'Upload details of an optimization screen: <input type="file" name="file" /> <input type="button" value="Upload" onclick="Plate.uploadScreen(this)" id="createscreenbtn"/>'+
					'</div></form>'+
					'';
				}
			} else {
				new Ajax.Request('/api/screen/'+data.screenid, {
					method:'get',
					onSuccess:function(transport){
						if(!AjaxUtils.checkResponse(transport)){ return false; }
						new Ajax.Request(tab.dataset.apiurl,{
							method:'get',
							onSuccess:function(transport){
								if(!AjaxUtils.checkResponse(transport)){ return false; }
								var screen=transport.responseJSON.screen;
								var contentBefore='<div style="text-align:right">'+
									'<span style="float:left"><a href="/screen/'+screen.id+'">'+screen.name+'</a>';
									if(1==screen.isstandard){
										contentBefore+=' (Standard screen)';
									} else {
										contentBefore+=' (Optimization screen)';
									}
									contentBefore+='</span>';
									if(canEdit){
										contentBefore+='<input type="button" value="Change..." onclick="Plate.beginSetScreen(Plate.afterSetScreen)"';
									}
									contentBefore+='</div>';
								var headers=['Well number','Description'];
								var cellTemplates=['{{wellnumber}}','{{description}}'];
								$("screens_body").table({
									'headers':headers,
									'cellTemplates':cellTemplates,
									'contentBefore':contentBefore
								}, transport.responseJSON);
							},
							onFailure:AjaxUtils.checkResponse
						});
					}, 
					onFailure:AjaxUtils.checkResponse
				});			
			}
		},
	  	 
		beginSetScreen: function(handler){
			new Ajax.Request('/api/screen/isstandard/1?pagesize=25',{
				method:'get',
				onSuccess:function(transport){
					if(!AjaxUtils.checkResponse(transport)){ return false; }
					Plate.showScreenList(transport.responseJSON, handler);
				},
				onFailure:function(transport){
					AjaxUtils.checkResponse(transport);
				},
			});

		},
		showScreenList: function(response, handler){
			var mb=ui.modalBox({
				'title':'Choose the screen',
				'content':'Just a moment...'
			});
			Plate.doAfter=handler;
			mb.dataset.pagesize=25;
			mb.table({
				'headers':['Name','Manufacturer',''],
				'cellTemplates':['{{name}}','{{manufacturer}}','<input type="button" value="Choose" onclick="Plate.chooseStandardScreen(this)">']
			}, response);		
		},
		chooseStandardScreen: function(btn){
			btn.up("tr").addClassName("updating");
			var screen=btn.up("tr").rowData;
			Plate.setScreen(screen.id);
		},
		uploadScreen: function(btn){
			btn.form.rows.value=data.rows;
			btn.form.cols.value=data.cols;
			if(0==btn.form.file.files.length){ alert('Choose a screen description file to upload'); return false; }
			btn.options={ afterSuccess:Plate.setUploadedScreen };
			ui.submitForm(btn);
		},
		setUploadedScreen: function(responseJSON){
			var screen=responseJSON.created;
			Plate.setScreen(screen.id);
		},
		
		setScreen: function(screenId){
			new Ajax.Request('/api/plate/'+data.id,{
				method:'patch',
				parameters:{
					csrfToken:csrfToken,
					screenid:screenId
				},
				onSuccess:function(transport){
					if(!AjaxUtils.checkResponse(transport)){ return false; }
					Plate.afterSetScreen(transport);
				},
				onFailure:function(transport){
					AjaxUtils.checkResponse(transport);
				},
			});
		},
		afterSetScreen: function(transport){
			data=transport.responseJSON.updated;
			Plate.renderScreenTab();
			ui.closeModalBox();
		},

	 	/*
	 	 * DROP CONDITIONS tab
	 	 */
		renderDropConditionsTab:function(){
			/*
			 * First implementation, assumes same across entire plate
			 */
			if(!data.plateType || !data.welldrops){
				$("drops_body").innerHTML="Just a moment...";
				window.setTimeout(Plate.renderDropConditionsTab,100);
				return;
			}
			var units=['uL','nL'];
			var unitsOptions='';
			units.each(function(u){
				unitsOptions+='<option value="'+u+'">'+u.replace("u","&#181;")+'</option>';
			});
			
			$("drops_body").innerHTML="";
			var dropMap=PlateType.getDropMapElement(data.plateType, $("drops_body"));
			dropMap.style.height="100%";
			dropMap.style.width=dropMap.getHeight()+"px";
			var drops=dropMap.select(".dropmapwell");
			drops.each(function(drop){
				drop.style.textAlign="center";
				var dropNumber=drop.dataset.dropnumber;
				var protAmount="";
				var protUnit="uL";
				var wellAmount="";
				var wellUnit="uL";

				for(i=0;i<data.welldrops.length;i++){
					var wd=data.welldrops[i];
					if(wd.dropnumber==dropNumber){
						protAmount=wd.proteinsolutionamount;
						protUnit=wd.proteinsolutionunit;
						wellAmount=wd.wellsolutionamount;
						wellUnit=wd.wellsolutionunit;
						break;
					}
				}
				
				if(canEdit){
					var out="<h3>Well solution:</h3>";
					out+='<div style="display:inline-block;width:6.25em;border:1px solid #666;border-radius:0.25em">';
					out+='<input type="text" style="width:2em;height:1.5em" name="wellsolutionamount" value="'+wellAmount+'" />';
					out+='<select style="border:none;width:3em;height:1.8em" name="wellsolutionunit">'+unitsOptions.replace('"'+wellUnit+'"','"'+wellUnit+'" selected="selected"')+'</select>';
					out+='</div>';
					out+='<hr style="margin:0.5em"/>';
					out+='<h3>Protein solution:</h3>';
					out+='<div style="display:inline-block;width:6.25em;border:1px solid #666;border-radius:0.25em">';
					out+='<input type="text" style="width:2em;height:1.5em" name="proteinsolutionamount" value="'+protAmount+'" />';
					out+='<select style="border:none;width:3em;height:1.8em" name="proteinsolutionunit">'+unitsOptions.replace('"'+protUnit+'"','"'+protUnit+'" selected="selected"')+'</select>';
					out+='</div>';
					drop.innerHTML+=out;
					drop.select("input,select").each(function(elem){
						elem.observe("keyup",Plate.updateWellSolutions);
						elem.observe("change",Plate.updateWellSolutions);
						elem.observe("blur",Plate.updateWellSolutions);
					});
				} else {
					drop.innerHTML+='<h3>Protein solution:</h3>';
					var protContent=protAmount+protUnit.replace("u","&#181;");
					if(""==protAmount || ""==protUnit){ protContent="(Not set)"; }
					drop.innerHTML+=protContent;
					drop.innerHTML+='<hr style="margin:0.5em"/>';
					drop.innerHTML+="<h3>Well solution:</h3>";
					var wellContent=wellAmount+wellUnit.replace("u","&#181;");
					if(""==wellAmount || ""==wellUnit){ wellContent="(Not set)"; }
					drop.innerHTML+=wellContent;
				}
			});
		},

		updateWellSolutions:function(evt){
			window.clearTimeout(submitTimer);
			var field=evt.target;
			var drop=field.up("td");
			if(field.up("label,td")){ field.up("label,td").removeClassName("invalidfield"); }
			drop.select("input,select").each(function(elem){
				if(!validator.validate(elem)){
					drop.addClassName("invalidfield");
					return false;
				}
			});
			window.submitTimer=setTimeout(function(){ Plate.doUpdateWellSolutions(field) },1500);
		},
		doUpdateWellSolutions:function(field){
			/*
			 * First implementation, assumes solutions are same for all drops in same position for whole plate
			 */
			var drop=field.up("td");
			if(drop.hasClassName("updating")){
				return false;
			}
			drop.removeClassName("invalidfield");
			drop.addClassName("updating");
			var parameters={ csrfToken:csrfToken};
			parameters[field.name]=field.value;
			parameters['selectionDrop']=drop.dataset.dropnumber;
			new Ajax.Request("/api/plate/"+data.id,{
				method:"patch",
				parameters:parameters,
				onSuccess:Plate.updateWellSolutions_onSuccess,
				onFailure:Plate.updateWellSolutions_onFailure
			});
		},
		updateWellSolutions_onSuccess:function(transport){
			/*
			 * First implementation, assumes solutions are same for all drops in same position for whole plate
			 */
			if(!AjaxUtils.checkResponse(transport)){ return false; }
			var updatedDrops=transport.responseJSON.updated.updateddrops;
			if(!updatedDrops || 0==updatedDrops.length){ return false; }
			firstUpdatedDrop=updatedDrops[0];
			var dropCells=$("drops_body").select(".dropmapwell");
			dropCells.each(function(dropCell){
				if(dropCell.dataset.dropnumber==firstUpdatedDrop.dropnumber){
					['proteinsolutionamount','proteinsolutionunit','wellsolutionamount','wellsolutionunit'].each(function(field){
						dropCell.down('[name='+field+']').value=firstUpdatedDrop[field];
					});
					dropCell.removeClassName("updating");
				}
			});
		},
		updateWellSolutions_onFailure:function(transport){
			AjaxUtils.checkResponse(transport);
		},
		
		getPlateType:function(){
			new Ajax.Request('/api/platetype/'+data.platetypeid,{
				method:"get",
				onSuccess:Plate.getPlateType_onSuccess,
				onFailure:Plate.getPlateType_onFailure,
			});
		},
		getPlateType_onSuccess:function(transport){
			if(!AjaxUtils.checkResponse(transport)){ return false; }
			data.plateType=transport.responseJSON;
		},
		getPlateType_onFailure:function(transport){
			AjaxUtils.checkResponse(transport);
		},

		
		/*
		 * INSPECTIONS tab of plate view
		 */
		writeInspectionLink: function(obj,field){
			return ImagingSession.getLink(obj,field);
		},
		
		/*
		 * Best score in, e.g., Project's plates tab
		 */
		renderPlateBestScoreCell:function(item){
			if(""==item.bestscorelabel){ return '-'; }
			return '<span style="float:right;width:20px;background-color:#'+item.bestscorecolor+'">&nbsp;</span>'+item.bestscorelabel;
		},
		
}



var PlateType={
		
		getDropMapElement:function(plateType, parent){
			var t=document.createElement("table");
			t.className="dropmap";
			var dropMap=plateType.dropmapping.split(",");
			dropMap.each(function(row){
				var tr=document.createElement("tr");
				for(c=0;c<row.length;c++){
					var td=document.createElement("td");
					var content=row[c];
					if(parseInt(content)){ 
						td.className="dropmapwell";
						td.dataset.dropnumber=content;
						var lbl=document.createElement("div");
						lbl.className="welllabel";
						lbl.innerHTML=content;
						td.appendChild(lbl);
					} else if("R"==content){
						//Reservoir
						td.className="dropmapreservoir";
					} else if("E"==content){
						//Empty well
						td.className="dropmapempty";
					} else if("X"==content){
						//Dead space on the plate
						td.className="dropmapdead";
					}
					tr.appendChild(td);
				}
				t.appendChild(tr);
			});
			if(null!=parent){ parent.appendChild(t); }
			return t;
		}
		
}


var ImagingSession={
	
		getLink: function(obj,field){
			var lighttype=obj.lighttype;
			var label=obj[field];
			if('imageddatetime'==field){ label=ui.friendlyDate(label); }
			return ImagingSession.getLightPathIcon(lighttype)+'&nbsp;<a href="/imagingsession/{{id}}">'+label+'</a>';
		},
	
		getLightPathIcon: function(lightTypeName){
			var types=['Visible','UV'];
			var offset=60*Math.max(0, types.indexOf(lightTypeName));
			return '<span class="lightbulb" style="background-position:0 -'+offset+'px" title="'+lightTypeName+'">&nbsp;</span>';
		}
			
}


var CrystallizationScreen={ //don't call it Screen - almost guaranteed to conflict with some UI thing or other

		getConditionCell:function(obj,field){
			if(1==data.isstandard && canEdit){
				return '<form action="/api/screencondition/'+obj.id+'/" method="patch"><input type="text" name="description" value="'+ obj["description"] +'" /></form>';
			}
			return obj[field];
		},
		
		adjustConditionsTableForEdit:function(){
			if(!$("conditions_body_table")){
				window.setTimeout(CrystallizationScreen.adjustConditionsTableForEdit,50);
				return;
			}
			if($("conditions_body_table").adjustedForEdit){
				return;
			}
			var cells=$$('#conditions_body_table td+td');
			cells.each(function(c){
				c.style.width="85%";
				var inp=c.down("input");
				if(inp){
					inp.style.width="99%";
					inp.observe("keyup", function(){ ui.updateFormField(inp)});
					inp.dataset.oldvalue=inp.value;
				}
			});
			$("conditions_body_table").adjustedForEdit=true;
		},

}

var Protein = {
		
		codonAsAmino:{
			"ATT":"I", "ATC":"I", "ATA":"I", "CTT":"L", "CTC":"L", "CTA":"L", "CTG":"L", "TTA":"L",
			"TTG":"L", "GTT":"V", "GTC":"V", "GTA":"V", "GTG":"V", "TTT":"F", "TTC":"F", "ATG":"M",
			"TGT":"C", "TGC":"C", "GCT":"A", "GCC":"A", "GCA":"A", "GCG":"A", "GGT":"G", "GGC":"G",
			"GGA":"G", "GGG":"G", "CCT":"P", "CCC":"P", "CCA":"P", "CCG":"P", "ACT":"T", "ACC":"T",
			"ACA":"T", "ACG":"T", "TCT":"S", "TCC":"S", "TCA":"S", "TCG":"S", "AGT":"S", "AGC":"S",
			"TAT":"Y", "TAC":"Y", "TGG":"W", "CAA":"Q", "CAG":"Q", "AAT":"N", "AAC":"N", "CAT":"H",
			"CAC":"H", "GAA":"E", "GAG":"E", "GAT":"D", "GAC":"D", "AAA":"K", "AAG":"K", "CGT":"R",
			"CGC":"R", "CGA":"R", "CGG":"R", "AGA":"R", "AGG":"R", "TAA":"*", "TAG":"*", "TGA":"*",
		},
		
		dnaToProtein:function(dna){
			dna=dna.replace(/\s/g,"");
			prot="";
			var dnaParts=dna.match(/.{1,3}/g);
			dnaParts.each(function(codon){
				var amino=Protein.codonAsAmino[codon];
				if(!amino){ return false; }
				prot+=amino;
			});
			return prot;
		},
		
		formatDnaSequence:function(seq){
			if(!seq || ""==seq){ return false; }
			var seqParts=seq.match(/.{1,3}/g);
			seq=seqParts.join(" ").toUpperCase();
			return seq;
		},

		formatProteinSequence:function(seq){
			if(!seq || ""==seq){ return false; }
			var seqParts=seq.match(/.{1,10}/g);
			seq=seqParts.join(" ").toUpperCase();
			return seq;
		},

}
