<?php $pageTitle='User: '.$data['fullname'];
include realpath(__DIR__).'/../_common/header.php'; ?>
<script type="text/javascript"><?php include realpath(__DIR__).'/../../model/user/extensions.js'; ?></script>
<script type="text/javascript">
document.observe("dom:loaded",function(){
	
	ui.grid();

	//basic page laout first
	if(isAdmin || userId==data['id'] /* TODO && using database authentication */){
		var detailsBox=grid.box({ 
			classes:'r1 c1 h2 w1',
			title:'Details'
		});
		var passwordBox=grid.box({ 
			classes:'r3 c1 h1 w1',
			title:'Change password'
		});
			                   	
	} else {
		var detailsBox=grid.box({ 
			classes:'r1 c1 h3 w1',
			title:'Details'
		});
	}

	
	var ts=grid.tabSet({ classes:'r1 c2 h3 w2' });

	//see ../model/extensions.js
	userExtensions.tabsBefore(ts);	

	if(isAdmin || userId==data['id'] /* TODO && using database authentication */){

		if(data.isadmin==1){ //User BEING VIEWED is an administrator
			ts.tab({ 
				id:'projects', 
				label:'Projects', 
				content:data.fullname+' is an administrator, and has full rights on all projects.', 
			 });
		 } else {
			ts.tab({ 
				id:'projects', 
				label:'Projects', 
				url:'/api/user/'+data['id']+'/project', 
				successHandler:writePermissions
			 });
		 }
		ts.tab({ 
			id:'memberships', 
			label:'Groups', 
			url:'/api/user/'+data['id']+'/usergroup',
			headers:['Name','Is group admin'],
			cellTemplates:['<a href="/usergroup/{{id}}">{{name}}</a>',[ui.checkmark,'isgroupadmin'] ]
		 });

	} else {
		ts.tab({ 
			id:'more', 
			label:'Info', 
			content:'If you aren\'t an administrator, you can\'t see other users\' project and group information', 
		 });
	}

	//see ../model/extensions.js
	userExtensions.tabsAfter(ts);	

	
	if(undefined!==passwordBox){
		var pfrm=passwordBox.form({
			action:'/api/user/'+data['id'],
			classes:'create'
		});
		if(!isAdmin){
			pfrm.passwordField({ label:"Old", name:'oldpassword', value:'', readonly:false });
		}
		pfrm.passwordField({ label:"New", name:'password1', value:'', readonly:false});
		pfrm.passwordField({ label:"New again", name:'password2', value:'', readonly:false });
		pfrm.buttonField({ label:"Change", id:"changepassword", onclick:changePassword });
	}


	var frm=detailsBox.form({
		action:'/api/user/'+data['id'],
	});
	frm.textField({ label:"Full name", name:'fullname', value:data['fullname'], readonly:!isAdmin });
	if(isAdmin){
		frm.textField({ label:"Email address", name:'email', value:data['email'] });
		frm.textField({ label:"Username", name:'name', value:data['name'], readonly:!isAdmin });
		frm.checkbox({ label:"Account is active", name:'isactive', value:data['isactive'] });
	}

	if(""==data.supervisorid || 0==data.supervisorid){
		frm.roleField({
			readonly:!isAdmin,
			label:"Supervisor", 
			name:'supervisorid', 
			otherType:'user',
			labelField:'fullname',
			headers:['Name'],
			cellTemplates:['{{fullname}}']
		});
	} else {
		new Ajax.Request('/api/user/'+data.supervisorid, {
			method:'get',
			onSuccess:function(transport){
				var supervisor=transport.responseJSON;
				frm.roleField({
					readonly:!isAdmin,
					label:"Supervisor", 
					name:'supervisorid', 
					otherId:supervisor.id, 
					otherName:supervisor.fullname, 
					otherType:'user',
					labelField:'fullname',
					headers:['Name'],
					cellTemplates:['{{fullname}}']
				});
			},
			onFailure:function(){}
		});
	}
	
});

function changePassword(evt){
	var btn=$(evt.target);
	var frm=btn.up("form");
	var oldPasswordField=frm.down("[name=oldpassword]");
	var new1Field=frm.down("[name=password1]");
	var new2Field=frm.down("[name=password2]");
	if(oldPasswordField && ""==oldPasswordField.value){
		alert("Old password is required");
		return false;
	} else if(new1Field.value!=new2Field.value || ""==new1Field.value){
		alert("New password: Both fields must match");
		return false;
	}
	btn.up("label").addClassName("updating");
	var body="csrfToken="+csrfToken+"&password="+new1Field.value;
	if(oldPasswordField){ body +="&oldpassword="+oldPasswordField.value; }
	new Ajax.Request("/api/user/"+data['id'], {
		method:"patch",
		postBody:body,
		onSuccess:changePassword_onSuccess,
		onFailure:changePassword_onFailure
	});
}
function changePassword_onSuccess(transport){
	if(!transport.responseJSON || transport.responseJSON.error){ return changePassword_onFailure(transport); }
	$("changepassword").up("label").removeClassName("updating");
}
function changePassword_onFailure(transport){
	$("changepassword").up("label").removeClassName("updating");
	if(transport.responseJSON && transport.responseJSON.error){ 
		alert(transport.responseJSON.error);
	} else {
		alert(transport.responseText);
	}
}

function writePermissions(transport){
	if(!transport.responseJSON){
		$("projects_body").innerHTML="Could not understand reply from server:</br></br>"+transport.responseText;
		return;
	}
	$("projects_body").addClassName("hastable");
	var permissionTypes=['read','update','create','delete'];
	var out='<table><tr><th>Project</th><th>Read</th><th>Update</th><th>Create</th><th>Delete</th></tr>';
	transport.responseJSON.rows.each(function(proj){
		var ownerFlag='';
		if(1==proj.isowner){ ownerFlag=' (owner)'; }
		out+='<tr><td><a href="/project/'+proj.id+'">'+proj.name+'</a>'+ownerFlag+'</td>';
		//Read-only permissions, cannot edit
		permissionTypes.each(function(t){
			if(1==proj.isowner){
				out+='<td><img src="/images/icons/yes.gif" title="Because '+data.fullname+' owns the project" id=""/></td>';
			} else if(!!proj.permissions[t]){
				var label="From group";
				if(proj.permissions[t].length>1){ label+="s"; }
				label+=": ";
				proj.permissions[t].each(function(perm){
					label+=perm.usergroupname+", ";
				});
				label=label.slice(0,-2);
				out+='<td><img src="/images/icons/yes.gif" title="'+label+'" id=""/></td>';
			} else {
				out+='<td><img src="/images/icons/no.gif" id=""/></td>';
			}
		});
		out+='</tr>';
	});
	out+='</table>';
	$("projects_body").innerHTML=out;
}


</script>
<?php include realpath(__DIR__).'/../_common/footer.php'; ?>